<?php
/**
 * Esto de aquí esta para coger los enlaces de descarga de cada capítulo pasandole
 * la url del capitulo. Devuelve un array de dos dimensiones, la primera con la 
 * posicion del enlace y la segunda con los datos
 * "enlace"
 * "servidor"
 * "idioma"
 * "subtitulos"
 * "comentario"
 * "fecha"
 * "tipo"
 * 
 * Hay "@" delante de los "loadHTML" para que no saquen errores
 */
function sacar_enlaces_capitulo($url) {
//Por si hace falta lo de las cookies se puede sacar de
//http://stackoverflow.com/questions/10958491/get-cookie-with-file-get-contents-in-php
    $opts = array(
        'http' => array(
            'method' => "GET",
            'header' => "Accept-language: en\r\n" .
            //"Cookie: foo=bar\r\n" .
            "Referer: http://www.seriespepito.com\r\n".
            "User-Agent: Mozilla/5.0 (Windows NT 6.3; WOW64; rv:29.0) Gecko/20100101 Firefox/29.0"
        )
    );
    stream_context_set_default($opts); //Esto cambia las cabeceras del file_get_contents por las que nos interesan
    $html = file_get_contents($url);
    $dom = new DOMDocument(); //Se usa un DOM HTML para ir inspeccionando la pagina
    @$dom->loadHTML($html);
    
    //Se define $k para los arrays en dos dimensiones
    $k=0;
    for ($i = 0; $i < $dom->getElementsByTagName("tbody")->length; $i++) {
        $html_tbody = $dom->saveXML($dom->getElementsByTagName("tbody")->item($i));
        $dom_tbody = new DOMDocument();
        @$dom_tbody->loadHTML($html_tbody);
        $n_enlaces = 5; //Esto es para limitar los enlaces ya que hay algunos hostings que con cierto numero de enlaces no tienen tiempo de ejecutar el script cuando hay muchos
        if($dom_tbody->getElementsByTagName("tr")->length > $n_enlaces){
            unset($random);
            $random = array();
            //Esto es para sacar enlaces aleatorios y no siempre los $n_enlaces primeros
            //Se calcula la posición del enlace y luego se pasa en otro bucle for
            for($r=0;$r<$n_enlaces;$r++){
                $aleatorio=rand(0,$dom_tbody->getElementsByTagName("tr")->length-1);
                foreach($random as $numero){
                    if($numero == $aleatorio){
                        $r--;
                        break;
                    }
                }
                if(($r) == count($random)){
                    $random[]= $aleatorio;
                }
            }
        }else {
            $n_enlaces = $dom_tbody->getElementsByTagName("tr")->length;
        }
        //Ahora con este bucle sacamos los enlaces que tenemos que visitar para verlos
        for ($j = 0; $j < $n_enlaces; $j++) {
            $html_tbody_tr = $dom_tbody->saveXML($dom_tbody->getElementsByTagName("tr")->item($random[$j]));
            $dom_tbody_tr = new DOMDocument();
            @$dom_tbody_tr->loadHTML($html_tbody_tr);
            //Aquí se saca la información que hace falta del enlace
            //Idioma y subtitulos
            switch($dom_tbody_tr->getElementsByTagName("td")->item(0)->nodeValue){
                case 0:
                    $enlaces[$k]["idioma"] = 1;
                    break;
                case 1:
                    $enlaces[$k]["idioma"] = 2;
                    break;
                case 2:
                    $enlaces[$k]["idioma"] = 3;
                    break;
                case 3:
                    $enlaces[$k]["idioma"] = 3;
                    $enlaces[$k]["subtitulos"] = 1;
                    break;
            }
            //Fecha
            $enlaces[$k]["fecha"]=$dom_tbody_tr->getElementsByTagName("td")->item(1)->nodeValue;
            
            //Servidor
            //Se pone substr porque hay caracteres antes del nombre del servidor
            $enlaces[$k]["servidor"]=substr($dom_tbody_tr->getElementsByTagName("td")->item(2)->nodeValue,8);
            
            //Comentario
            $enlaces[$k]["comentario"]=$dom_tbody_tr->getElementsByTagName("td")->item(5)->nodeValue;
            
            //Y aquí se saca a donde hay que ir a por los archivos
            $link = $dom_tbody_tr->getElementsByTagName("a")->item(0)->getAttribute("href");
            //Y ahora leemos el enlace para ver donde esta el archivo de verdad
            $opts = array(
                'http' => array(
                    'method' => "GET",
                    'header' => "Accept-language: en\r\n" .
                    //"Cookie: foo=bar\r\n" .
                    "Referer: http://www.seriespepito.com\r\n". //Se puede usar $link para poner la referencia exacta
                    "User-Agent: Mozilla/5.0 (Windows NT 6.3; WOW64; rv:29.0) Gecko/20100101 Firefox/29.0"
                )
            );
            stream_context_set_default($opts);            
            $html_archivo = file_get_contents($link);
            $dom_archivo = new DOMDocument();
            @$dom_archivo->loadHTML($html_archivo);
            //Esto es para urgar en el script y sacar el enlace y to lo vivo
            $scripts = $dom_archivo->getElementsByTagName("script");
            foreach ($scripts as $script){
                if(!$script->getAttribute("src")){
                    $contenido_script=$script->nodeValue; //Esto es lo que tiene el jquery con la clase
                    break;
                }
            }
            //Sacamos las cookies que nos manda la pagina
            $cookies = array();
            foreach ($http_response_header as $hdr) {
                if (preg_match('/^Set-Cookie:\s*([^;]+)/', $hdr, $matches)) {
                    parse_str($matches[1], $tmp);
                    $cookies += $tmp;
                }
            }
            //Ahora contamos los caracteres hasta el de antes de la variable magica y la buscamos en el script
            //Y buscamos la url del enlace
            $letra_magica=$contenido_script[strpos($contenido_script, "$('.")+4];
            $clase_enlace=$letra_magica.hash("sha256",reset($cookies));
            $lineas_script = str_replace(array("\r\n", "\r"), "\n", $contenido_script); //Esto es para sacar la linea de las variables magicas
            $lineas_script = explode("\n", $lineas_script);
            //Buscamos el enlace falso
            $xpath     = new DOMXPath($dom_archivo);
            $summaries = $xpath->query('//a[@class="'.$clase_enlace.'"]');
            preg_match("/www.enlacespepito.com\/([^\.]*).html/i", $summaries->item(0)->getAttribute("href"),$contenido_url);
            $enlace_falso=$contenido_url[1];
            //Dividimos las letras cachondas para arreglar el enlace y se las ponemos al enlace falso
            $letras_cachondas = explode(";",trim($lineas_script[6]));
            for($pos=0;$pos<(count($letras_cachondas)-2);$pos++){
                preg_match("/\[([^\.]*)\]=\"([^\.]*)\"/i",$letras_cachondas[$pos],$cosota);
                $enlace_falso[$cosota[1]]=$cosota[2];
            }
            
            $enlace_bueno="http://www.enlacespepito.com/".$enlace_falso.".html";
            //Y con este churro sacamos el enlace. BIEN :D
            $opts = array(
                'http' => array(
                    'method' => "GET",
                    'header' => "Accept-language: en\r\n" .
                    //"Cookie: foo=bar\r\n" .
                    "Referer: ".$link."\r\n".
                    "User-Agent: Mozilla/5.0 (Windows NT 6.3; WOW64; rv:29.0) Gecko/20100101 Firefox/29.0"
                )
            );
            stream_context_set_default($opts);
            $url_descarga = get_headers($enlace_bueno);
            $enlaces[$k]["enlace"] = substr($url_descarga[4],10);
            $enlaces[$k]["tipo"] = $i;
            
            //se suma uno a $k para que en la siguiente vuelta este en otra posicion
            //en la primera dimension
            $k++;
        }
    }
    
    return $enlaces;
}